Kea: isc::dhcp::Subnet4ConfigParser Class Reference

| Kea 3.2.0-git

isc::dhcp::Subnet4ConfigParser Class Reference

More...

`#include <dhcp_parsers.h>`

Inheritance diagram for isc::dhcp::Subnet4ConfigParser:
[legend]

## Public Member Functions
| Subnet4ConfigParser (bool check_iface=true)
| Constructor.
Subnet4Ptr | parse (data::ConstElementPtr subnet, bool encapsulate_options=true)
| Parses a single IPv4 subnet configuration and adds to the Configuration Manager.
Public Member Functions inherited from isc::dhcp::SubnetConfigParser
| SubnetConfigParser (uint16_t family, bool check_iface=true)
| constructor
virtual | ~SubnetConfigParser ()
| virtual destructor (does nothing)
Public Member Functions inherited from isc::dhcp::BaseNetworkParser
template<typename DdnsOwnerTypePtr>
void | parseDdnsParameters (const data::ConstElementPtr &config, DdnsOwnerTypePtr owner)
| Parses parameters pertaining to DDNS behavior.
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t.
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t.
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value.
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet.

## Protected Member Functions
virtual boost::shared_ptr< PoolsListParser > | createPoolsListParser () const
| Returns an instance of the `Pools4ListParser` to be used in parsing the address pools.
void | initSubnet (data::ConstElementPtr params, asiolink::IOAddress addr, uint8_t len)
| Instantiates the IPv4 Subnet based on a given IPv4 address and prefix length.
void | validateResv (const Subnet4Ptr &subnet, ConstHostPtr host)
| Verifies the host reservation address is in the subnet range.
Protected Member Functions inherited from isc::dhcp::SubnetConfigParser
virtual boost::shared_ptr< OptionDataListParser > | createOptionDataListParser () const
| Returns an instance of the `OptionDataListParser` to be used in parsing the option-data structure.
void | createSubnet (isc::data::ConstElementPtr data)
| Create a new subnet using a data from child parsers.
SubnetPtr | parse (isc::data::ConstElementPtr subnet, bool encapsulate_options)
| parses a subnet description and returns Subnet{4,6} structure
Protected Member Functions inherited from isc::dhcp::BaseNetworkParser
void | parseAdaptiveLeaseTimeParam (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses parameter related to adaptive lease time.
void | parseAllocatorParams (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses parameters pertaining to allocator selection.
void | parseCacheParams (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses parameters related to lease cache settings.
void | parseCommon (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses common parameters.
void | parseDdnsParams (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses parameters pertaining to DDNS behavior.
void | parseOfferLft (const data::ConstElementPtr &network_data, Network4Ptr &network)
| Parses offer-lifetime parameter (v4 only).
void | parsePdAllocatorParams (const data::ConstElementPtr &network_data, Network6Ptr &network)
| Parses parameters pertaining to prefix delegation allocator selection.
void | parseTeePercents (const data::ConstElementPtr &network_data, NetworkPtr &network)
| Parses parameters related to "percent" timers settings.
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type, target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope.
template<typename int_type>
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope.

## Additional Inherited Members
Public Types inherited from isc::dhcp::BaseNetworkParser
typedef std::function< void(const isc::dhcp::ClientClass &)> | ClassAdderFunc
Static Public Member Functions inherited from isc::dhcp::BaseNetworkParser
static void | getAdditionalClassesElem (data::ConstElementPtr params, ClassAdderFunc adder_func)
| Fetches the element for either 'evaluate-additional-classes' or deprecated 'require-client-classes'.
static void | getClientClassesElem (data::ConstElementPtr params, ClassAdderFunc adder_func)
| Fetches the element for either 'client-classes' or deprecated 'client-class'.
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type.
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present.
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child.
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope.
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope.
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range.
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element.
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope.
template<typename T>
static void | rangeCheckedInteger (isc::data::ConstElementPtr scope, const std::string &name, T &output_value)
| Fetches a range-checked integer parameter from a scope.
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values.
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list.
Protected Attributes inherited from isc::dhcp::SubnetConfigParser
uint16_t | address_family_
| Address family: `AF_INET` or `AF_INET6`.
bool | check_iface_
| Check if the specified interface exists in the system.
PoolStoragePtr | pools_
| Storage for pools belonging to this subnet.
isc::dhcp::Network::RelayInfoPtr | relay_info_
| Pointer to relay information.
isc::dhcp::SubnetPtr | subnet_
| Pointer to the created subnet object.

## Detailed Description

This class parses a single IPv4 subnet.

This is the IPv4 derivation of the SubnetConfigParser class and it parses the whole subnet definition. It creates parsersfor received configuration parameters as needed.

Definition at line 599 of file dhcp_parsers.h.

## Constructor & Destructor Documentation

## ◆ Subnet4ConfigParser()

isc::dhcp::Subnet4ConfigParser::Subnet4ConfigParser | ( | bool | check_iface = true | ) |

Constructor.

stores global scope parameters, options, option definitions.

Parameters

  check_iface | Check if the specified interface exists in the system.

Definition at line 714 of file dhcp_parsers.cc.

References isc::dhcp::SubnetConfigParser::SubnetConfigParser().

Here is the call graph for this function:

## Member Function Documentation

## ◆ createPoolsListParser()

boost::shared_ptr< PoolsListParser > isc::dhcp::Subnet4ConfigParser::createPoolsListParser | ( |  | ) | const
| protectedvirtual

Returns an instance of the `Pools4ListParser` to be used in parsing the address pools.

This function can be overridden in the child classes to supply a custom parser for the pools.

Returns
  an instance of the `Pools4ListParser`.

Implements isc::dhcp::SubnetConfigParser.

Definition at line 1001 of file dhcp_parsers.cc.

Referenced by parse().

## ◆ initSubnet()

void isc::dhcp::Subnet4ConfigParser::initSubnet | ( | data::ConstElementPtr | params,
|  | asiolink::IOAddress | addr,
|  | uint8_t | len )
| protectedvirtual

Instantiates the IPv4 Subnet based on a given IPv4 address and prefix length.

Parameters

  params | Data structure describing a subnet.
  addr | is IPv4 address of the subnet.
  len | is the prefix length

client-class processing is now generic and handled in the common code (see isc::data::SubnetConfigParser::createSubnet)

Implements isc::dhcp::SubnetConfigParser.

Definition at line 774 of file dhcp_parsers.cc.

References isc::dhcp::Network::addAdditionalClass(), isc::dhcp::Network::allowClientClass(), isc::dhcp::SubnetConfigParser::check_iface_, isc::dhcp::Subnet4::create(), D6O_INTERFACE_ID, isc::dhcp::DHCPSRV_CFGMGR_NEW_SUBNET4, isc::dhcp::dhcpsrv_logger, isc::db::error, isc::dhcp::BaseNetworkParser::getAdditionalClassesElem(), isc::data::SimpleParser::getBoolean(), isc::dhcp::BaseNetworkParser::getClientClassesElem(), isc::data::SimpleParser::getInteger(), isc::data::SimpleParser::getString(), isc::dhcp::IfaceMgr::instance(), isc_throw, LOG_INFO, isc::dhcp::Pkt4::MAX_FILE_LEN, isc::dhcp::Pkt4::MAX_SNAME_LEN, isc::dhcp::BaseNetworkParser::parseAdaptiveLeaseTimeParam(), isc::dhcp::BaseNetworkParser::parseCacheParams(), isc::dhcp::BaseNetworkParser::parseCommon(), isc::dhcp::BaseNetworkParser::parseDdnsParams(), isc::dhcp::BaseNetworkParser::parseOfferLft(), isc::dhcp::BaseNetworkParser::parseTeePercents(), isc::dhcp::SubnetConfigParser::subnet_, and isc::dhcp::Option::V6.

Here is the call graph for this function:

## ◆ parse()

Subnet4Ptr isc::dhcp::Subnet4ConfigParser::parse | ( | data::ConstElementPtr | subnet,
|  | bool | encapsulate_options = true )

Parses a single IPv4 subnet configuration and adds to the Configuration Manager.

Parameters

  subnet | A new subnet being configured.
  encapsulate_options | a boolean parameter indicating if the parsed options should be encapsulated with suboptions.

Returns
  a pointer to created Subnet4 object

Parse Pools first.

Definition at line 719 of file dhcp_parsers.cc.

References isc::data::SimpleParser::checkKeywords(), createPoolsListParser(), isc::dhcp::CfgMgr::getStagingCfg(), isc::dhcp::CfgMgr::instance(), isc_throw, isc::dhcp::HostReservationsListParser< HostReservationParserType >::parse(), isc::dhcp::SubnetConfigParser::parse(), isc::dhcp::BaseNetworkParser::parseAllocatorParams(), isc::dhcp::SubnetConfigParser::pools_, isc::dhcp::SubnetConfigParser::relay_info_, isc::dhcp::SimpleParser4::SUBNET4_PARAMETERS, isc::dhcp::SubnetConfigParser::subnet_, and validateResv().

Here is the call graph for this function:

## ◆ validateResv()

void isc::dhcp::Subnet4ConfigParser::validateResv | ( | const Subnet4Ptr & | subnet,
|  | ConstHostPtr | host )
| protected

Verifies the host reservation address is in the subnet range.

Parameters

  subnet | pointer to the subnet
  host | pointer to the host reservation

Exceptions

  DhcpConfigError | when the address is not in the subnet range.

Definition at line 991 of file dhcp_parsers.cc.

References isc_throw, isc::asiolink::IOAddress::isV4Zero(), and isc::asiolink::IOAddress::toText().

Referenced by parse().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- dhcp_parsers.h
- dhcp_parsers.cc